/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.soafaces.bundle.client.rpc;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * This is a container for name/value proeprties that are avaialble to a Tasklet.
 * If used with Tasklets, these properties are shared between all the job runs
 * of a Tasklet. They are a way to dynamically and programmatically share state
 * between multiple Tasklet/job runs.
 *
 * @author Sam Taha
 */
public interface AppCookie extends IsSerializable {


  /**
   * <p>
   * Cookies are Tasklet/Weblet properties that can used by a Tasklet as it runs.
   * This method returns only <code>APP_SCOPE</code>
   * cookie properties. <code>APP_SCOPE</code> cookies are name/value properties shared between all running
   * jobs. These cookies are shared between all job runs and can be viewed by the
   * Weblet/RuntimeViewer GUI interfaces associated with a Tasklet.
   * </p>
   *
   * @param name Name of the cookie.
   *
   * @return Value of the cookie.
   */
  String getCookie(String name);

  /**
   * Cookies set here will not be made persistent on the server until the
   * <code>WebletContext.saveAppCookie()</code> has been made.
   *
   * <p>
   * Note, if you need to save complex data structures in the Cookie, for
   * viewing by the Weblet later, it is recommended you save this
   * as a serialized JSON string. This can then be parsed more efficiently by the GWT
   * Weblet for display in the GUI.
   * </p>
   */
  void setCookie(String name, String value);
}
